# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FSPYTHON_METADATA = Metadata(
    id="2424f19a382cf96fd7771ce3d7180d81a8324105.boutiques",
    name="fspython",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


FspythonParameters = typing.TypedDict('FspythonParameters', {
    "__STYX_TYPE__": typing.Literal["fspython"],
    "args": typing.NotRequired[list[str] | None],
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "fspython": fspython_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class FspythonOutputs(typing.NamedTuple):
    """
    Output object returned when calling `fspython(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def fspython_params(
    args: list[str] | None = None,
) -> FspythonParameters:
    """
    Build parameters.
    
    Args:
        args: Arguments passed to the program.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "fspython",
    }
    if args is not None:
        params["args"] = args
    return params


def fspython_cargs(
    params: FspythonParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("python3")
    cargs.append("[OPTION]")
    if params.get("args") is not None:
        cargs.extend(params.get("args"))
    return cargs


def fspython_outputs(
    params: FspythonParameters,
    execution: Execution,
) -> FspythonOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FspythonOutputs(
        root=execution.output_file("."),
    )
    return ret


def fspython_execute(
    params: FspythonParameters,
    execution: Execution,
) -> FspythonOutputs:
    """
    Freesurfer's embedded Python interpreter.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FspythonOutputs`).
    """
    params = execution.params(params)
    cargs = fspython_cargs(params, execution)
    ret = fspython_outputs(params, execution)
    execution.run(cargs)
    return ret


def fspython(
    args: list[str] | None = None,
    runner: Runner | None = None,
) -> FspythonOutputs:
    """
    Freesurfer's embedded Python interpreter.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        args: Arguments passed to the program.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FspythonOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FSPYTHON_METADATA)
    params = fspython_params(
        args=args,
    )
    return fspython_execute(params, execution)


__all__ = [
    "FSPYTHON_METADATA",
    "FspythonOutputs",
    "FspythonParameters",
    "fspython",
    "fspython_params",
]
